(cl:in-package #:demo-derive.produce)


(defgeneric (setf postgres-dao) (new-value product))
(defgeneric construct-producer-schema (producer))
(defgeneric delete-product* (controller producer product))
(defgeneric dependencies (producer))
(defgeneric dependencies-tree* (producer ids extra-arguments dependency-producers &optional parent))
(defgeneric dependency-tree-node-product-key (dependency-tree-node))
(defgeneric direct-dependencies (producer))
(defgeneric existing-products* (controller producer ids producer-parameters))
(defgeneric find-producer* (producers-collection name))
(defgeneric invoke-with-products-group/product/dependencies (producer products-group product dependencies extra-arguments))
(defgeneric make-postprocessing-product* (controller &rest initargs))
(defgeneric make-postprocessing-product-dependency* (controller &rest initargs))
(defgeneric make-postprocessing-products-group* (controller))
(defgeneric name (producer))
(defgeneric name-to-producer-dictionary (producers-collection))
(defgeneric path-to-schema (producer))
(defgeneric postgres-connection-list (config))
(defgeneric postgres-dao (product))
(defgeneric register-producer* (producers-collection producer))
(defgeneric send-producers-collection-to-database* (procedures-collection))
(defgeneric fetch-producers-collection-from-database* (procedures-collection))
(defgeneric source-path (python-producer))
(defgeneric update-dao* (controller object))
(defgeneric sync-dao* (controller object))

(defgeneric make-products-group-state* (controller products-group dependencies-forest
                                        &key automatic-deletion))
(defgeneric completedp* (products-group-state))
(defgeneric select-pending* (products-group-state))
(defgeneric try-fullfill* (products-group-state index))
(defgeneric fullfill-node (node state))
(defgeneric propagate-failure (node products-group-state))
(defgeneric propagate-success (node products-group-state))
(defgeneric signal-product-error (producer node &key reason))
(defgeneric directly-dependent-nodes (products-group-state node))
(defgeneric (setf directly-dependent-nodes) (new-value products-group-state node))
(defgeneric dependent-nodes (products-group-state node))
(defgeneric direct-dependency-nodes (products-group-state node))
(defgeneric (setf direct-dependency-nodes) (new-value products-group-state node))
(defgeneric dependency-nodes (products-group-state node))
(defgeneric remove-from-waiting (products-group-state node))
(defgeneric remove-from-pending (products-group-state node))
(defgeneric move-from-waiting-to-pending (products-group-state node))
(defgeneric fullfill-products-group-state* (controller products-group-state))
(defgeneric lock-product* (dao-controller product))
(defgeneric root-node-p (dependency-tree-node))
(defgeneric find-producer-by-id* (collection id))
